'                       *****  IBM Yahtzee 1.24  *****
'    (C) 1990-1992  Milton Bradley, Inc.  IBM Version by Jeremy P. Dailey
'
'    Jeremy P. Dailey, 17 Prospect St., Delevan, NY 14042-9704

' $DYNAMIC

DECLARE SUB PrintOnScreen (Row, Column, Colour, Text$)
DECLARE SUB PrintRedDie (Location, Die)
DECLARE SUB PrintBlackDie (Location, Die)
DECLARE SUB GetInitials (Player, Inputted$)
DECLARE SUB WaitForKey ()
DECLARE SUB BossScreen ()
DECLARE SUB ClearDisplayArea ()
DECLARE SUB PrintRollMessages ()
DECLARE SUB PrintSelectMessages ()
DECLARE SUB PrintScoreCard ()
DECLARE SUB ProgramInfo ()
DECLARE FUNCTION Dices$ (Number, Part)
DECLARE FUNCTION Justify$ (Stuff$, Filler$, Length)
DECLARE FUNCTION GetKey$ (Filter$, CaseSensitive)
DECLARE FUNCTION GetYN$ ()
DECLARE FUNCTION WillScore (Area, Dice())

Dimensions:
        DIM Dice(5), PlayerScore(18, 4), Score(18), PlayerName$(4), KeepTrack(4)
        RANDOMIZE TIMER

Beginning:
        COLOR 15, 1, 1
        CLS
        ProgramInfo
        PrintOnScreen 12, 0, 12, "How many players? (1-4) "

GetPlayers:
        Player$ = INKEY$: IF Player$ = CHR$(27) THEN GOTO EndProgram
        IF Player$ = "" THEN GOTO GetPlayers ELSE IF LEFT$(Player$, 1) < "1" OR LEFT$(Player$, 1) > "4" THEN GOTO GetPlayers
        PRINT Player$;
        Player = ASC(Player$) - 48
        ERASE PlayerScore, PlayerName$, KeepTrack
        REDIM PlayerScore(18, Player), PlayerName$(Player), KeepTrack(Player)
        FOR Counter = 1 TO Player
                PrintOnScreen 13 + Counter, 27, 13, "Player #" + CHR$(Counter + 48) + "'s Initials: "
              
GetInitials:
                GetInitials Counter, Inputted$
                IF Inputted$ = "" THEN GOTO GetInitials
                PlayerName$(Counter) = Inputted$
        NEXT Counter
        COLOR 14, 1, 1
        CLS
        GOSUB InitPlayers

BeginGame:
        GOSUB CheckFlag
        IF Flag = 0 THEN GOTO EndGame
        FOR CurrentPlayer = 1 TO Player
                COLOR 15, 7
                PrintOnScreen 2, 61 + (5 * (CurrentPlayer - 1)), 15, PlayerName$(CurrentPlayer)
                COLOR 15, 1
                GOSUB DisplayScore
                TimesRolled = 0
                Dice(1) = -7: Dice(2) = -7: Dice(3) = -7: Dice(4) = -7: Dice(5) = -7

CheckRoll:
                TimesRolled = TimesRolled + 1
                GOSUB RollDice
                IF TimesRolled = 3 THEN GOSUB Scoring ELSE GOSUB SelectDice: GOTO CheckRoll
                COLOR 0, 7
                PrintOnScreen 2, 61 + (5 * (CurrentPlayer - 1)), 0, PlayerName$(CurrentPlayer)
                COLOR 0, 1
        NEXT CurrentPlayer
        GOTO BeginGame
 
EndGame:
        ClearDisplayArea
        PrintOnScreen 23, 3, 15, "Press any key to continue...."
        WaitForKey
       
DisplayResults:
        COLOR 15, 4, 4: CLS
        PrintOnScreen 1, 0, 15, "Yahtzee Game Results:"
        PrintOnScreen 3, 0, 15, "Ŀ"
        PrintOnScreen 4, 0, 15, "#Int1S2S3S4S5S6S3K4KFHSSLSYHCHY B63 UT LT GT "
        PrintOnScreen 5, 0, 15, "Ĵ"
        FOR CurrentPlayer = 1 TO Player
                FOR Temp = 1 TO 18
                        IF PlayerScore(Temp, CurrentPlayer) = -1 THEN PlayerScore(Temp, CurrentPlayer) = 0
                NEXT Temp
                Text$ = "" + CHR$(CurrentPlayer + 48) + "" + RIGHT$("   " + PlayerName$(CurrentPlayer), 3) + ""
                FOR Temp = 1 TO 13
                        Text$ = Text$ + RIGHT$("  " + LTRIM$(RTRIM$(STR$(PlayerScore(Temp, CurrentPlayer)))), 2) + ""
                NEXT Temp
                Text$ = Text$ + RIGHT$("   " + LTRIM$(RTRIM$(STR$(PlayerScore(14, CurrentPlayer)))), 3) + ""
                Text$ = Text$ + RIGHT$("  " + LTRIM$(RTRIM$(STR$(PlayerScore(15, CurrentPlayer)))), 2) + ""
                FOR Temp = 16 TO 17
                        Text$ = Text$ + RIGHT$("   " + LTRIM$(RTRIM$(STR$(PlayerScore(Temp, CurrentPlayer)))), 3) + ""
                NEXT Temp
                Text$ = Text$ + RIGHT$("    " + LTRIM$(RTRIM$(STR$(PlayerScore(18, CurrentPlayer)))), 4) + ""
                PrintOnScreen 4 + (CurrentPlayer * 2), 0, 15, Text$
                IF CurrentPlayer = Player THEN Text$ = "" ELSE Text$ = "Ĵ"
        PrintOnScreen 5 + (CurrentPlayer * 2), 0, 15, Text$
        NEXT CurrentPlayer
        PrintOnScreen 24, 0, 30, "Press any key to continue...."
        WaitForKey
        GOTO CheckScores

Scoring:
        PrintSelectMessages
        Area = 1
       
CheckValid:   
        IF PlayerScore(Area, CurrentPlayer) <> -1 THEN Area = Area + 1: GOTO CheckValid

SelectBox:
        COLOR 15, 5
        IF WillScore(Area, Dice()) > 0 THEN PrintOnScreen Score(Area), 60 + (5 * (CurrentPlayer - 1)), 15, Justify$(STR$(WillScore(Area, Dice())), " ", 4) ELSE PrintOnScreen Score(Area), 60 + (5 * (CurrentPlayer - 1)), 15, "    "
        COLOR 15, 1
        Key$ = INKEY$: IF Key$ = "" THEN GOTO SelectBox
        IF UCASE$(LEFT$(Key$, 1)) = "B" THEN BossScreen: GOTO SelectBox
        IF UCASE$(LEFT$(Key$, 1)) = "Q" THEN GOSUB QuitGame: IF QuitGameFlag = 0 THEN PrintSelectMessages: GOTO SelectBox:  ELSE IF QuitGameFlag = 1 THEN GOTO Beginning ELSE GOTO EndProgram
        IF UCASE$(LEFT$(Key$, 1)) = "S" THEN SOUND 500, .3: GOSUB SuggestScores: GOTO SelectBox
        IF Key$ = CHR$(13) THEN LOCATE Score(Area), 38: SOUND 500, .3: COLOR 15, 7: PRINT " "; : GOTO FigureScore
        IF (Key$ <> CHR$(0) + CHR$(72)) AND (Key$ <> CHR$(0) + CHR$(80)) THEN GOTO SelectBox
        SOUND 500, .3
        COLOR 1, 7
        PrintOnScreen Score(Area), 60 + (5 * (CurrentPlayer - 1)), 2, SPACE$(4)
        COLOR 15, 1
        IF Key$ = CHR$(0) + CHR$(72) THEN
                Flag = 1
                WHILE Flag = 1
                        Area = Area - 1
                        IF Area = 0 THEN Area = 13
                        IF PlayerScore(Area, CurrentPlayer) = -1 THEN Flag = 0
                WEND
        ELSEIF Key$ = CHR$(0) + CHR$(80) THEN
                Flag = 1
                WHILE Flag = 1
                        Area = Area + 1
                        IF Area = 14 THEN Area = 1
                        IF PlayerScore(Area, CurrentPlayer) = -1 THEN Flag = 0
                WEND
        END IF
        GOTO SelectBox

FigureScore:
        IF PlayerScore(Area, CurrentPlayer) <> -1 THEN SOUND 110, 1: GOTO SelectBox
        PlayerScore(Area, CurrentPlayer) = WillScore(Area, Dice())
        IF WillScore(14, Dice()) = 100 AND Area <> 12 THEN PlayerScore(14, CurrentPlayer) = PlayerScore(14, CurrentPlayer) + 100
        SOUND 400, .2
       
ReTotal:
        PlayerScore(15, CurrentPlayer) = -1
        PlayerScore(16, CurrentPlayer) = 0
        PlayerScore(17, CurrentPlayer) = 0
        PlayerScore(18, CurrentPlayer) = 0
        FOR Temp1 = 1 TO 6
                IF PlayerScore(Temp1, CurrentPlayer) <> -1 THEN PlayerScore(16, CurrentPlayer) = PlayerScore(16, CurrentPlayer) + PlayerScore(Temp1, CurrentPlayer)
        NEXT Temp1
        IF PlayerScore(16, CurrentPlayer) > 62 THEN PlayerScore(15, CurrentPlayer) = 35: PlayerScore(16, CurrentPlayer) = PlayerScore(16, CurrentPlayer) + 35
        FOR Temp1 = 7 TO 14
                IF PlayerScore(Temp1, CurrentPlayer) <> -1 THEN PlayerScore(17, CurrentPlayer) = PlayerScore(17, CurrentPlayer) + PlayerScore(Temp1, CurrentPlayer)
        NEXT Temp1
        PlayerScore(18, CurrentPlayer) = PlayerScore(16, CurrentPlayer) + PlayerScore(17, CurrentPlayer)
        GOSUB DisplayScore
        SLEEP 1
        RETURN

RollDice:
        COLOR 14, 1: Colour = 14
        FOR Temp2 = 1 TO 5
                PrintOnScreen 3 + ((Temp2 - 1) * 4), 3, 14, CHR$(Temp2 + 48)
        NEXT Temp2
        FOR Temp2 = 1 TO 5
                IF Dice(Temp2) <> ABS(Dice(Temp2)) THEN GOSUB ReRoll
        NEXT Temp2
        PrintRollMessages
        PrintOnScreen 24, 21, 15, "Roll #" + CHR$(TimesRolled + 48)
        RETURN

ReRoll:
        Dice(Temp2) = INT(RND(1) * 6) + 1
        SOUND 150, .3: SOUND 32767, .1
        PrintRedDie Temp2, Dice(Temp2)
        RETURN

SelectDice:
        Key$ = GetKey$("12345BQRS", 0)
        IF UCASE$(Key$) = "R" THEN RETURN
        IF UCASE$(Key$) = "B" THEN BossScreen: GOTO SelectDice
        IF UCASE$(Key$) = "Q" THEN GOSUB QuitGame: IF QuitGameFlag = 0 THEN PrintRollMessages: GOTO SelectDice:  ELSE IF QuitGameFlag = 1 THEN GOTO Beginning ELSE GOTO EndProgram
        IF UCASE$(Key$) = "S" THEN GOSUB ClearFlashing: GOSUB SuggestScores: GOTO SelectDice
        IF Key$ < "1" OR Key$ > "5" THEN GOTO SelectDice
        Dice(VAL(Key$)) = -Dice(VAL(Key$)): SOUND 650, .5
        IF Dice(VAL(Key$)) <> ABS(Dice(VAL(Key$))) THEN PrintBlackDie VAL(Key$), ABS(Dice(VAL(Key$))) ELSE PrintRedDie VAL(Key$), ABS(Dice(VAL(Key$)))
        GOTO SelectDice
        RETURN

CheckFlag:
        Flag = 0
        FOR Temp2 = 1 TO 13
                FOR Temp3 = 1 TO Player
                IF PlayerScore(Temp2, Temp3) = -1 THEN Flag = 1
                NEXT Temp3
        NEXT Temp2
        RETURN

InitPlayers:
        PrintScoreCard
        FOR Temp2 = 1 TO Player
                FOR Temp3 = 1 TO 18
                        PlayerScore(Temp3, Temp2) = -1
                NEXT Temp3
        NEXT Temp2
        LOCATE 1, 1
        RESTORE DisplayData
        FOR Temp2 = 1 TO 18
                READ Score(Temp2)
        NEXT Temp2
        FOR Temp2 = 1 TO Player
                PlayerScore(16, Temp2) = 0
                PlayerScore(17, Temp2) = 0
                PlayerScore(18, Temp2) = 0
                COLOR 0, 7
                PrintOnScreen 2, 61 + (5 * (Temp2 - 1)), 0, PlayerName$(Temp2)
                COLOR 0, 1
        NEXT Temp2
        RETURN

DisplayScore:
        COLOR 0, 7
        FOR Temp2 = 1 TO 18
                PrintOnScreen Score(Temp2), 60 + (5 * (CurrentPlayer - 1)), 0, "    "
                IF PlayerScore(Temp2, CurrentPlayer) = -1 THEN GOTO EndLoop
                PrintOnScreen Score(Temp2), 60 + (5 * (CurrentPlayer - 1)), 0, Justify$(STR$(PlayerScore(Temp2, CurrentPlayer)), " ", 4)

EndLoop:
        NEXT Temp2
        COLOR 14, 1
        RETURN
        
SuggestScores:
        FOR Temp4 = 1 TO 13
                COLOR 15, 1
                Calculated = WillScore(Temp4, Dice())
                IF Calculated = 0 OR PlayerScore(Temp4, CurrentPlayer) <> -1 THEN GOTO EndSuggest
                PrintOnScreen Score(Temp4), 60 + (5 * (CurrentPlayer - 1)), 15, Justify$(STR$(Calculated), " ", 4)
                IF Temp4 = 12 THEN COLOR , 4: PrintOnScreen Score(Temp4), 60 + (5 * (CurrentPlayer - 1)), 15, "  50"
EndSuggest:
        NEXT Temp4
        PrintOnScreen 25, 1, 12, "Press any key...."
        WaitForKey
        PrintOnScreen 25, 1, 12, "                 "
        COLOR 0, 7
        FOR Temp4 = 1 TO 13
                PrintOnScreen Score(Temp4), 60 + (5 * (CurrentPlayer - 1)), 0, "    "
        NEXT Temp4
        GOSUB DisplayScore
        COLOR 15, 1
        IF TimesRolled <> 3 THEN PrintOnScreen 24, 21, 15, "Roll #" + CHR$(TimesRolled + 48)
        RETURN

ClearFlashing:
        FOR Die = 1 TO 5
               IF Dice(Die) <> ABS(Dice(Die)) THEN Dice(Die) = -Dice(Die): PrintRedDie Die, Dice(Die)
        NEXT Die
        RETURN

CheckScores:
        ON ERROR GOTO MakeFile
        OPEN "YAHTZEE.DAT" FOR INPUT AS #1
        CLOSE #1
        OPEN "YAHTZEE.DAT" FOR RANDOM AS #1 LEN = 5
        FIELD #1, 2 AS HighScore$, 3 AS GoodPlayer$
        FOR CurrentPlayer = 1 TO Player
                FOR Record = 1 TO 100
                        KeepTrack(CurrentPlayer) = 101
                        GET #1, Record
                        IF CVI(HighScore$) >= PlayerScore(18, CurrentPlayer) THEN GOTO EndLoop1
                                        FOR Record2 = 100 TO Record STEP -1
                                                GET #1, Record2
                                                IF Record2 + 1 < 101 THEN PUT #1, Record2 + 1
                                        NEXT Record2
                        LSET HighScore$ = MKI$(PlayerScore(18, CurrentPlayer))
                        LSET GoodPlayer$ = PlayerName$(CurrentPlayer)
                        KeepTrack(CurrentPlayer) = Record
                        PUT #1, Record
                FOR OlderPlayer = 1 TO CurrentPlayer - 1
                        IF KeepTrack(OlderPlayer) >= KeepTrack(CurrentPlayer) THEN KeepTrack(OlderPlayer) = KeepTrack(OlderPlayer) + 1
                NEXT OlderPlayer
                GOTO EndCheckScores
              
EndLoop1:
                NEXT Record
      
EndCheckScores:
        NEXT CurrentPlayer

DisplayScores:
        COLOR 15, 5, 5
        CLS
        PrintOnScreen 1, 0, 14, "Top 100 Scores"
        FOR Counter = 1 TO 100
                Row = Counter - (20 * INT((Counter - 1) / 20)) + 3
                Column = (INT((Counter - 1) / 20)) * 14 + 1
                Colour = 15
                        COLOR 15, 5
                        FOR CurrentPlayer = 1 TO Player
                                IF KeepTrack(CurrentPlayer) = Counter THEN COLOR 15, 1
                        NEXT CurrentPlayer
                GET #1, Counter
                Text$ = RIGHT$("   #" + LTRIM$(RTRIM$(STR$(Counter))), 3) + "  " + LEFT$(GoodPlayer$ + "   ", 3) + " " + RIGHT$("    " + LTRIM$(RTRIM$(STR$(CVI(HighScore$)))), 4)
                PrintOnScreen Row, Column, Colour, Text$
        NEXT Counter
        CLOSE #1
        COLOR 15, 5

PlayAgain:
        PrintOnScreen 25, 0, 14, "Do you want to play again?  [Y/N]"
        IF GetYN$ = "Y" THEN GOTO Beginning
        GOTO EndProgram

MakeFile:
        ON ERROR GOTO BadError
        OPEN "YAHTZEE.DAT" FOR RANDOM AS #1 LEN = 5
        FIELD #1, 2 AS HighScore$, 3 AS GoodPlayer$
        FOR Counter = 1 TO 100
        LSET GoodPlayer$ = "   "
        LSET HighScore$ = MKI$(0)
        PUT #1, Counter
        NEXT Counter
        CLOSE #1
        RESUME CheckScores

BadError:
        RESUME PlayAgain

QuitGame:
        QuitGameFlag = 0
        ClearDisplayArea
        PrintOnScreen 22, 5, 14, "Quit / Restart / Continue?"
        Key$ = GetKey$("CQR" + CHR$(27), 0)
        IF Key$ = "C" OR Key$ = CHR$(27) THEN QuitGameFlag = 0
        IF Key$ = "R" THEN QuitGameFlag = 1
        IF Key$ = "Q" THEN QuitGameFlag = 2
        ClearDisplayArea
        RETURN

EndProgram:
        COLOR 7, 0, 0
        CLS
        END

DisplayData:
        DATA 4,5,6,7,8,9,14,15,16,17,18,19,20,21,11,12,23,24

REM $STATIC
SUB BossScreen
        PCOPY 0, 1
        COLOR 7, 0, 0
        CLS
        COLOR 0, 3
        PrintOnScreen 1, 1, 0, SPACE$(80)
        PrintOnScreen 1, 1, 0, "              Sort  Analysis  Compress  Help"
        PrintOnScreen 25, 1, 0, SPACE$(80)
        PrintOnScreen 25, 19, 0, "Press Esc key or F3 to terminate Surface Analysis"
        COLOR 7, 4
        PrintOnScreen 1, 1, 7, " COMPRESS V6 "
        COLOR 1, 7
        PrintOnScreen 2, 1, 1, SPACE$(80)
        PrintOnScreen 2, 1, 1, "DRV: A  B  C  D"
        COLOR 7, 0
        PrintOnScreen 2, 11, 7, " C "
        COLOR 15, 1
        FOR Row = 3 TO 23
                PrintOnScreen Row, 1, 7, "" + SPACE$(78) + ""
        NEXT Row
        PrintOnScreen 3, 1, 7, ""
        PrintOnScreen 3, 2, 7, STRING$(78, 196) + ""
        PrintOnScreen 18, 1, 7, "" + STRING$(78, 205) + ""
        PrintOnScreen 24, 1, 7, "" + STRING$(78, 205) + ""
        PrintOnScreen 4, 27, 7, "Disk(ette) Surface Analysis"
        PrintOnScreen 20, 3, 7, "On Pass 00 of"
        PrintOnScreen 20, 17, 15, "99 Passes"
        PrintOnScreen 21, 3, 7, "CURRENT SECTOR -     0000000"
        PrintOnScreen 22, 3, 7, "CURRENT CLUSTER -    00000"
        PrintOnScreen 19, 12, 7, "Elapsed time = 00:00:00"
        PrintOnScreen 20, 37, 7, "B - BOOT SECTOR     - ALLOCATED CLUSTER"
        PrintOnScreen 21, 37, 7, "F - FAT SECTOR      - UNALLOCATED CLUSTER"
        PrintOnScreen 22, 37, 7, "D - ROOT DIRECTORY * - UNREADABLE CLUSTER"
        PrintOnScreen 23, 37, 7, "X - BAD CLUSTER    4 - SECTORS PER CLUSTER"
        PrintOnScreen 19, 48, 7, "0 Percent Complete"
        COLOR 0, 3
        PrintOnScreen 20, 37, 0, "B"
        COLOR 4, 1
        PrintOnScreen 21, 37, 4, "F"
        OUT &H3D8, 9
        COLOR 1, 6
        PrintOnScreen 22, 37, 17, "D"
        COLOR 0, 4
        PrintOnScreen 23, 37, 16, "X"
        PrintOnScreen 22, 56, 16, "*"
        COLOR 9, 7
        PrintOnScreen 21, 56, 9, ""
        COLOR 15, 1
        PrintOnScreen 20, 56, 15, ""
        PrintOnScreen 23, 56, 15, "4"
        FOR Row = 5 TO 17
                PrintOnScreen Row, 2, 15, STRING$(78, 8)
        NEXT Row
        Sector = -1
        Cluster = 0
        Cycle = 1
        Flag$ = ""
        TimeValue = 0
        WHILE Flag$ = ""
                TimeValue = TimeValue + (1 / 27)
                Hours = INT(TimeValue / 3600)
                Minutes = INT(TimeValue / 60) - (Hours * 3600)
                Seconds = INT(TimeValue) - (Hours * 3600) - (Minutes * 60)
                OUT &H3D8, 9
                Sector = Sector + 1
                Area = Sector - INT(Sector / 4048) * 4048
                Area = INT(Area / 4)
                Column = INT(Area / 13) + 2
                Row = (Area - INT(Area / 13) * 13) + 5
                PrintOnScreen Row, Column, 0, ""
                PrintOnScreen 19, 27, 15, Justify$(STR$(Hours), "0", 2)
                PrintOnScreen 19, 30, 15, Justify$(STR$(Minutes), "0", 2)
                PrintOnScreen 19, 33, 15, Justify$(STR$(Seconds), "0", 2)
                PrintOnScreen 20, 11, 15, Justify$(STR$(Cycle), "0", 2)
                PrintOnScreen 21, 24, 15, Justify$(STR$(Sector), "0", 7)
                Cluster = INT((Sector - 115) / 4) + 2: IF Cluster < 2 THEN Cluster = 0
                Percent = INT(100 * Sector / 41734)
                PrintOnScreen 19, 46, 15, Justify$(STR$(Percent), " ", 3)
                PrintOnScreen 22, 24, 15, Justify$(STR$(Cluster), "0", 5)
                PrintOnScreen Row, Column, 15, ""
                Key$ = INKEY$
                IF Key$ = CHR$(27) OR Key$ = CHR$(0) + CHR$(61) THEN Flag$ = "STOP!!"
                IF Sector + 1 = 41735 THEN Sector = -1: Cycle = Cycle + 1
                IF Cycle = 100 THEN Flag$ = "STOP!!"
        WEND
        COLOR 15, 1, 1
        CLS
        PCOPY 1, 0
END SUB

SUB ClearDisplayArea
        PrintOnScreen 22, 1, 15, SPACE$(36)
        PrintOnScreen 23, 1, 15, SPACE$(36)
        PrintOnScreen 24, 1, 15, SPACE$(36)
END SUB

FUNCTION Dices$ (Number, Part)
        SELECT CASE Number
        CASE 1
                IF Part = 1 THEN Dices$ = "     " ELSE IF Part = 2 THEN Dices$ = "    " ELSE IF Part = 3 THEN Dices$ = "     "
        CASE 2
                IF Part = 1 THEN Dices$ = "    " ELSE IF Part = 2 THEN Dices$ = "     " ELSE IF Part = 3 THEN Dices$ = "    "
        CASE 3
                IF Part = 1 THEN Dices$ = "    " ELSE IF Part = 2 THEN Dices$ = "    " ELSE IF Part = 3 THEN Dices$ = "    "
        CASE 4
                IF Part = 1 THEN Dices$ = "   " ELSE IF Part = 2 THEN Dices$ = "     " ELSE IF Part = 3 THEN Dices$ = "   "
        CASE 5
                IF Part = 1 THEN Dices$ = "   " ELSE IF Part = 2 THEN Dices$ = "    " ELSE IF Part = 3 THEN Dices$ = "   "
        CASE 6
                IF Part = 1 THEN Dices$ = "  " ELSE IF Part = 2 THEN Dices$ = "     " ELSE IF Part = 3 THEN Dices$ = "  "
        END SELECT
END FUNCTION

SUB GetInitials (Player, Inputted$)
        Inputted$ = ""

GetInitial1:
        LOCATE 13 + Player, 51 - 1 + LEN(Inputted$)
        PRINT CHR$(219);
       
GetInitial2:
        KeyIn$ = INKEY$: IF KeyIn$ = "" THEN GOTO GetInitial2
        IF KeyIn$ = CHR$(8) AND Inputted$ = "" THEN GOTO GetInitial2
        IF KeyIn$ = CHR$(8) AND LEN(Inputted$) = 1 THEN LOCATE 13 + Player, 51: PRINT "  "; : Inputted$ = "": GOTO GetInitial1
        IF KeyIn$ = CHR$(8) THEN LOCATE 13 + Player, 51 - 2 + LEN(Inputted$): PRINT "  "; : Inputted$ = LEFT$(Inputted$, LEN(Inputted$) - 1): GOTO GetInitial1
        IF KeyIn$ = CHR$(13) AND Inputted$ = "" THEN GOTO GetInitial2
        IF KeyIn$ = CHR$(13) THEN LOCATE 13 + Player, 51 - 1 + LEN(Inputted$): PRINT " "; : GOTO GetInitial3
        IF ASC(KeyIn$) < 32 OR ASC(KeyIn$) > 126 THEN GOTO GetInitial2
        IF LEN(Inputted$) = 3 THEN BEEP: GOTO GetInitial2
        LOCATE 13 + Player, 51 - 1 + LEN(Inputted$)
        KeyIn$ = UCASE$(KeyIn$)
        PRINT KeyIn$;
        Inputted$ = Inputted$ + KeyIn$
        GOTO GetInitial1

GetInitial3:
END SUB

FUNCTION GetKey$ (Filter$, CaseSensitive)

GetKey1:
        Key$ = INKEY$
        IF Key$ = "" THEN GOTO GetKey1
        IF CaseSensitive = 0 THEN Key$ = UCASE$(Key$)
        IF INSTR(Filter$, Key$) = 0 THEN GOTO GetKey1
        GetKey$ = Key$

END FUNCTION

FUNCTION GetYN$

GetYN1:
        Key$ = INKEY$: IF Key$ = "" THEN GOTO GetYN1
        IF Key$ = CHR$(27) OR UCASE$(Key$) = "N" THEN GetYN$ = "N": GOTO GetYN2
        IF UCASE$(Key$) <> "Y" THEN GOTO GetYN1
        GetYN$ = "Y"

GetYN2:
END FUNCTION

FUNCTION Justify$ (Stuff$, Filler$, Length)
        Justify$ = RIGHT$(STRING$(Length, ASC(Filler$)) + LTRIM$(RTRIM$(Stuff$)), Length)
END FUNCTION

SUB PrintBlackDie (Location, Die)
        COLOR 15, 0
        PrintOnScreen 2 + ((Location - 1) * 4), 6, 15, Dices$(Die, 1)
        PrintOnScreen 3 + ((Location - 1) * 4), 6, 15, Dices$(Die, 2)
        PrintOnScreen 4 + ((Location - 1) * 4), 6, 15, Dices$(Die, 3)
        COLOR 15, 1
END SUB

SUB PrintOnScreen (Row, Column, Colour, Text$)
        IF Column = 0 THEN LOCATE Row, 40 - LEN(Text$) / 2: COLOR Colour: PRINT Text$;  ELSE LOCATE Row, Column: COLOR Colour: PRINT Text$;
END SUB

SUB PrintRedDie (Location, Die)
        COLOR 15, 4
        PrintOnScreen 2 + ((Location - 1) * 4), 6, 15, Dices$(Die, 1)
        PrintOnScreen 3 + ((Location - 1) * 4), 6, 15, Dices$(Die, 2)
        PrintOnScreen 4 + ((Location - 1) * 4), 6, 15, Dices$(Die, 3)
        COLOR 15, 1
END SUB

SUB PrintRollMessages
        ClearDisplayArea
        PrintOnScreen 22, 1, 14, "1-5"
        PrintOnScreen 22, 5, 15, "Toggle Die"
        PrintOnScreen 22, 21, 14, "S"
        PrintOnScreen 22, 22, 15, "uggest Scores"
        PrintOnScreen 23, 1, 14, "R"
        PrintOnScreen 23, 2, 15, "oll Toggled Dice"
        PrintOnScreen 23, 21, 14, "B"
        PrintOnScreen 23, 22, 15, "oss Key"
        PrintOnScreen 24, 1, 14, "Q"
        PrintOnScreen 24, 2, 15, "uit Game"
END SUB

SUB PrintScoreCard
        COLOR 0, 7
        PrintOnScreen 1, 37, 0, "Ŀ"
        PrintOnScreen 2, 37, 0, " Yahtzee Score Card                  "
        PrintOnScreen 3, 37, 0, "Ĵ"
        PrintOnScreen 4, 37, 0, " Ones                                "
        PrintOnScreen 5, 37, 0, " Twos                                "
        PrintOnScreen 6, 37, 0, " Threes                              "
        PrintOnScreen 7, 37, 0, " Fours                               "
        PrintOnScreen 8, 37, 0, " Fives                               "
        PrintOnScreen 9, 37, 0, " Sixes                               "
        PrintOnScreen 10, 37, 0, "Ĵ"
        PrintOnScreen 11, 37, 0, " 63 Bonus                            "
        PrintOnScreen 12, 37, 0, " Upper Total                         "
        PrintOnScreen 13, 37, 0, "Ĵ"
        PrintOnScreen 14, 37, 0, " Three of a Kind                     "
        PrintOnScreen 15, 37, 0, " Four of a Kind                      "
        PrintOnScreen 16, 37, 0, " Full House                          "
        PrintOnScreen 17, 37, 0, " Small Straight                      "
        PrintOnScreen 18, 37, 0, " Large Straight                      "
        PrintOnScreen 19, 37, 0, " Yahtzee                             "
        PrintOnScreen 20, 37, 0, " Chance                              "
        PrintOnScreen 21, 37, 0, " Yahtzee Bonus                       "
        PrintOnScreen 22, 37, 0, "Ĵ"
        PrintOnScreen 23, 37, 0, " Lower Total                         "
        PrintOnScreen 24, 37, 0, " Total Score                         "
        PrintOnScreen 25, 37, 0, ""
        COLOR 14, 1, 1
END SUB

SUB PrintSelectMessages
        ClearDisplayArea
        PrintOnScreen 22, 21, 14, ""
        PrintOnScreen 22, 24, 15, "Move Cursor"
        PrintOnScreen 22, 1, 14, "S"
        PrintOnScreen 22, 2, 15, "uggest Scores"
        PrintOnScreen 23, 21, 14, ""
        PrintOnScreen 23, 24, 15, "Enter Score"
        PrintOnScreen 23, 1, 14, "B"
        PrintOnScreen 23, 2, 15, "oss Key"
        PrintOnScreen 24, 1, 14, "Q"
        PrintOnScreen 24, 2, 15, "uit Game"
END SUB

SUB ProgramInfo
        PrintOnScreen 2, 0, 15, "IBM Yahtzee 1.24"
        PrintOnScreen 4, 0, 9, "Copyright (C) 1990-1992 Jeremy P. Dailey."
        PrintOnScreen 5, 0, 9, "Boss Screen Display - Copyright (C) 1992 Central Point Software."
        PrintOnScreen 6, 0, 9, "Written with Microsoft BASIC PDS 7.1 - Copyright (C) 1990 Microsoft Corp."
        PrintOnScreen 8, 0, 14, "This program is released to the public domain."
        PrintOnScreen 9, 0, 14, "Please distribute this game around."
        PrintOnScreen 19, 0, 15, "Jeremy P. Dailey"
        PrintOnScreen 20, 0, 15, "17 Prospect St."
        PrintOnScreen 21, 0, 15, "Delevan, NY  14042-9704"
        PrintOnScreen 23, 0, 15, "(716) 492-4541"
END SUB

SUB WaitForKey
        WHILE INKEY$ = ""
        WEND
END SUB

FUNCTION WillScore (Area, Dice())
        Flag2 = 0
        Flag3 = 0
        Calculated = 0
        SELECT CASE Area
       
        CASE 1 TO 6
                FOR Die = 1 TO 5
                        IF Dice(Die) = Area THEN Calculated = Calculated + Area
                NEXT Die
        CASE 7 TO 8
                Flag2 = 0
                FOR Value = 1 TO 6
                        Total = 0
                        FOR Die = 1 TO 5
                        IF Dice(Die) = Value THEN Total = Total + 1
                        NEXT Die
                        IF Total > (Area - 5) THEN Flag2 = 1
                NEXT Value
                IF Flag2 = 1 THEN Calculated = Dice(1) + Dice(2) + Dice(3) + Dice(4) + Dice(5)
        CASE 9
                Flag2 = 0
                Flag3 = 0
                FOR Value = 1 TO 6
                        Total = 0
                        FOR Die = 1 TO 5
                        IF Dice(Die) = Value THEN Total = Total + 1
                        NEXT Die
                        IF Total = 2 THEN Flag2 = 1
                        IF Total = 3 THEN Flag3 = 1
                        IF Total = 5 THEN Flag2 = 1: Flag3 = 1
                NEXT Value
                IF Flag2 = 1 AND Flag3 = 1 THEN Calculated = 25
        CASE 10
                FOR Counter = 1 TO 5
                        Flag3 = Dice(Counter)
                        Flag2 = 1
                        FOR Die = 1 TO 5
                                IF Dice(Die) = Flag3 + 1 THEN Flag2 = Flag2 + 1: Flag3 = Flag3 + 1: Die = 0
                        NEXT Die
                        IF Flag2 > 3 THEN Calculated = 30
                NEXT Counter
        CASE 11
                Flag2 = 1
                Flag3 = Dice(1)
                FOR Die = 2 TO 5
                        IF Dice(Die) < Flag3 THEN Flag3 = Dice(Die)
                NEXT Die
                FOR Die = 1 TO 5
                        IF Dice(Die) = Flag3 + 1 THEN Flag2 = Flag2 + 1: Flag3 = Flag3 + 1: Die = 0
                NEXT Die
                IF Flag2 = 5 THEN Calculated = 40
        CASE 12
                IF Dice(1) = Dice(2) AND Dice(2) = Dice(3) AND Dice(3) = Dice(4) AND Dice(4) = Dice(5) THEN Calculated = 50
        CASE 13
                Calculated = Dice(1) + Dice(2) + Dice(3) + Dice(4) + Dice(5)
        CASE 14
                IF WillScore(12, Dice()) = 50 THEN Calculated = 100 ELSE Calculated = 0
        END SELECT
        WillScore = Calculated
END FUNCTION

